! Marbles, a distinct element method code for simulating spheres
! Copyright (C) 2013 Joshua J. Cogliati

! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.

! This program is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! General Public License for more details.

! You should have received a copy of the GNU General Public License along
! with this program; if not, write to the Free Software Foundation, Inc.,
! 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

! NOTICE: Portions of this computer software were prepared by Battelle
! Energy Alliance, LLC, hereinafter BEA, under Contract
! No. DE-AC07-05ID14517 with the United States (U.S.) Department of
! Energy (DOE).  NEITHER THE UNITED STATES GOVERNMENT, NOR DOE, NOR
! BEA MAKE ANY WARRANTY, EXPRESSED OR IMPLIED, OR ASSUMES ANY
! LIABILITY OR RESPONSIBILITY FOR THE USE, ACCURACY, COMPLETENESS, OR
! USEFULNESS OR ANY INFORMATION, APPARATUS, PRODUCT, OR PROCESS
! DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT INFRINGE PRIVATELY
! OWNED RIGHTS.

! EXPORT RESTRICTIONS. The provider of this computer software and its
! employees and its agents are subject to U.S. export control laws that
! prohibit or restrict (i) transactions with certain parties, and (ii)
! the type and level of technologies and services that may be exported.
! You agree to comply fully with all laws and regulations of the United
! States and other countries (Export Laws) to assure that neither this
! computer software, nor any direct products thereof are (1) exported,
! directly or indirectly, in violation of Export Laws, or (2) are used
! for any purpose prohibited by Export Laws, including, without
! limitation, nuclear, chemical, or biological weapons proliferation.

module constants
  use types
  implicit none

  REAL(KIND=D_T) :: pebble_radius

  logical :: calculate_pebble_wear_vol

  REAL(KIND=D_T) :: kinetic_friction
  REAL(KIND=D_T) :: pp_static_friction 
  REAL(KIND=D_T) :: surface_static_friction

  !Improved static friction functions.
  logical :: use_static_friction
  real(kind=d_t) :: static_velocity_sqr_max, static_velocity_max
  real(kind=d_t) :: static_friction_hooke, surface_static_friction_hooke
  logical :: zero_static_slips, linear_static_velocity_clamp
  logical :: zero_long_slips, shorten_long_slips, decrease_long_slips
  real(kind=d_t) :: long_slip_sqr, long_slip, long_slip_mult
  real(kind=d_t) :: decrease_slip_mult, decrease_slip_slope

  !     if this is greater than 2*sqrt(hooke), than no oscillations
  REAL(KIND=D_T)  :: normal_dash_pot_constant
  REAL(KIND=D_T) :: transverse_dash_pot_constant

  !hooke forces in kg*m/(m*s**2)
  REAL(KIND=D_T) :: pebble_vessel_hooke

  !gravitational force in newtons (kg*m/s**2)
  REAL(KIND=D_T) :: gravitational_force

end module constants
